let table;
let square_dim = 45;
let border = 2;
let num_states = 8;
let num_years = 16;
let start = 70;
let end = start + num_years * square_dim;
let unique_state_codes = new Set();
let unique_years = new Set();
let lables = ['< 10', '10 .. 20', '20 .. 30', '30 .. 40', '> 40'];


function preload() {
    table = loadTable(
        'https://gist.githubusercontent.com/olga-kondr/8c0189b181cf74dea61c96b669e60260/raw/c3ec5a222078115fcef9c98bcc9869a2e1d0b329/ab_rate.csv', 
        'csv', 
        'header'
    );
}

function setup() {
    createCanvas(900, 500);
    background(250);
    for (let r = 0; r < table.getRowCount(); r++){
      let row = table.getRow(r);
      let state = row.getString(1);
      unique_state_codes.add(state); 
      let year = row.get(0);
      unique_years.add(year);
    }
    
}

function draw() {
  
    noStroke();
    fill(150, 150, 150);
    textSize(16);
    text('Abortion Rates for Group 15-17 Years Old', 200, 40);
    textSize(12);
    let x_ind = 0;
    let y_ind = 0;
  
    let colors = [color(0, 50, 0), color(0, 100, 0), color(0, 150, 0), color(0, 200, 0), color(0, 250, 0)]
  
    for (let r = 0; r < table.getRowCount(); r++) {
      noStroke();
      textSize(16);
      text(table.get(r,1), start - 30, start + 25 + square_dim * y_ind);
      text(table.get(r,0), start + square_dim * x_ind, start + square_dim * num_states + 25);
      let x = start + x_ind * square_dim;
      let y = start + y_ind * square_dim;
      let val = table.get(r, 2);
      if(val <= 10) 
        fill(colors[0]);
      if(val <= 20 & val > 10) 
        fill(colors[1]);
      if(val <= 30 & val > 20) 
        fill(colors[2]);
      if(val <= 40 & val > 30) 
        fill(colors[3]);
      if(val > 40) 
        fill(colors[4]);
      stroke(color(190, 190, 190));
      square(x, y, square_dim);
      fill(150, 150, 150);
      noStroke();
      if(x_ind == num_years-1){
          x_ind = 0;
          y_ind += 1; 
          }
      else {
        x_ind += 1;
      }
    }

    noStroke();
    push();
    let axisy = radians(270);
    translate(20, 180);
    rotate(axisy);
    textSize(16);
    text("States", -80, 0);
    textSize(12);
    pop();

    noStroke();
    textSize(16);
    text('Years', 360, 490);
    textSize(12);
  
    
    textSize(14);
    text('Abortion Rate', 800, start + 20);
    textSize(12);
    text('per 1000 women', 800, start + 40);
    for (let i = 0; i < 5; i++){
      fill(colors[i]);
      stroke(color(190,190,190));
      square(820, start + 50 + i*square_dim/2, square_dim/2);
      noStroke();
      fill(150, 150, 150);
      text(lables[i], 850, start + 65 + i*square_dim/2);
      noStroke();
      textSize(12);
    }
}